#include <pspkernel.h>
#include <pspdisplay.h>
#include <string.h>
#include "lib.h"

PSP_MODULE_INFO("main", PSP_MODULE_USER, 1, 1);

const u32 module_sdk_version = 0x06060010;

const char *path = "ms0:/PSP/SAVEDATA/TNV_54321/TN.BIN";
char buf[0x4000];

int thread_start(SceSize args __attribute__((unused)), void *argp __attribute__((unused)))
{
	sceDisplaySetFrameBuf((void*)0x44000000, 512, PSP_DISPLAY_PIXEL_FORMAT_8888, 1);

	SceUID fd = sceIoOpen(path, PSP_O_RDONLY, 0777);
	sceIoRead(fd, buf, sizeof(buf));
	sceIoClose(fd);

	memcpy((void *)0x10000, buf, sizeof(buf));

	ClearCachesForUser();

	void (* Start)(const char *, int, int, int) = (void *)0x10000;
	Start(path, 0, 0, 0);

	sceKernelExitGame();

	return 0;
}

int module_start(SceSize args, void *argp)
{
	SceUID thid = sceKernelCreateThread("user_main", thread_start, 32, 0x40000, THREAD_ATTR_USER, NULL);

	if (thid >= 0)
		sceKernelStartThread(thid, args, argp);

	return 0;
}

int module_stop(SceSize args __attribute__((unused)), void *argp __attribute__((unused)))
{
	return 0;
}
